#include "object.h"

Object::Object ()
{
  this->readFromObjFile ("cube.obj");
    
  glEnableClientState (GL_VERTEX_ARRAY);
  glVertexPointer(3, GL_FLOAT, 0, vertices->getArray());
  
  listNumber = glGenLists(1);
  glNewList (listNumber, GL_COMPILE);

  glColor3f(1.0,0,0);
  glBegin(GL_QUADS);
  
  for (int i=0; i<=faces->getCount();++i)
    {
      printf ("%i, %i\n", i, (int) faces->getArray()[i]);
      glArrayElement((int)faces->getArray()[i] -1);
    }
  /*  glArrayElement(1);
  glArrayElement(3);
  glArrayElement(2);

  glArrayElement(2);
  glArrayElement(3);
  glArrayElement(5);
  glArrayElement(4);

  glArrayElement(4);
  glArrayElement(5);
  glArrayElement(7);
  glArrayElement(6);

  glArrayElement(6);
  glArrayElement(7);
  glArrayElement(1);
  glArrayElement(0);

  glArrayElement(1);
  glArrayElement(7);
  glArrayElement(5);
  glArrayElement(3);

  glArrayElement(6);
  glArrayElement(0);
  glArrayElement(2);
  glArrayElement(4);
  */
  

  glEnd();
  glEndList();
}

void Object::draw ()
{
  glCallList (listNumber);

}




bool Object::readFromObjFile (char* fileName)
{
  if ( (OBJ_FILE = fopen (fileName, "r")) == NULL)
    {
      printf ("file: %s not found.\n", fileName);
      return false;
    }
  else
    {
      char Buffer[10];
      vertices = new Array();
      faces = new Array();

      while (fscanf (OBJ_FILE, "%s", Buffer) != EOF)
	{
	  //	  printf ("%s\n",Buffer);

	  // case we read it is a vertex
	  if (!strcmp (Buffer, "v"))
	    {  
	      for (int i=0; i<=2;i++)
		{
		  fscanf (OBJ_FILE, "%s", Buffer);
		  //printf ("float: %f\n", atof(Buffer));
		  vertices->addEntry(atof(Buffer));
		}
	    }
	  // case we read a Face
	  if (!strcmp (Buffer, "f"))
	    {  
	      for (int i=0; i<=3;i++)
		{
		  char* pointTo;
		  fscanf (OBJ_FILE, "%s", Buffer);
		  pointTo = strstr (Buffer, "/");
		  pointTo[0] = '\0';
		  printf ("int: %s\n", Buffer);
		  faces->addEntry(atof(Buffer));
		}
	    }
	}
      vertices->finalizeArray();
      fclose (OBJ_FILE);
      return true;
    }
}
